<?php
namespace Incoviba\Repository\Venta;

use Incoviba\Common\Define;
use Incoviba\Common\Ideal;
use Incoviba\Common\Implement;
use Incoviba\Model;
use Incoviba\Repository;

class Propietario extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Repository\Direccion $direccionRepository)
    {
        parent::__construct($connection);
        $this->setTable('propietario');
    }

    protected function getKey(): string
    {
        return 'rut';
    }

    public function create(?array $data = null): Define\Model
    {
        $map = (new Implement\Repository\MapperParser(['dv', 'nombres']))
            ->register('apellido_paterno', (new Implement\Repository\Mapper())
                ->setProperty('apellidos')
                ->setFunction(function($data) {
                    $arr = [
                        'paterno' => $data['apellido_paterno']
                    ];
                    if ($data['apellido_materno'] !== '') {
                        $arr['materno'] = $data['apellido_materno'];
                    }
                    return $arr;
                }))
            ->register('direccion', (new Implement\Repository\Mapper())
                ->setProperty('datos')
                ->setFunction(function($data) {
                    $datos = new Model\Venta\Datos();
                    if ($data['direccion'] !== null and $data['direccion'] !== 0) {
                        $datos->direccion = $this->direccionRepository->fetchById($data['direccion']);
                    }
                    return $datos;
                }))
            ->register('representante', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    if ($data['representante'] === null or $data['representante'] === 0) {
                        return null;
                    }
                    return $this->fetchById($data['representante']);
                }))
            ->register('otro', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    if ($data['otro'] === null) {
                        return null;
                    }
                    return $data['otro'] !== 0;
                })
                ->setDefault(null));
        return $this->parseData(new Model\Venta\Propietario(), $data, $map);
    }

    public function save(Define\Model $model): Define\Model
    {
        $model->rut = $this->saveNew(
            ['dv', 'nombres', 'apellido_paterno', 'apellido_materno', 'direccion', 'otro', 'representante'],
            [$model->dv, $model->nombres, $model->apellidos['paterno'], $model->apellidos['materno'], $model->datos->direccion->id, $model->otro->rut ?? 0, $model->representante->rut ?? 0]
        );
        return $model;
    }

    public function edit(Define\Model $model, array $new_data): Define\Model
    {
        return $this->update($model, ['dv', 'nombres', 'apellido_paterno', 'apellido_materno', 'direccion', 'otro', 'representante'], $new_data);
    }
}
